import { reactive, onMounted, ref, ElMessage, ElMessageBox, http, getGroupUrl, RegularVerification, verification, PaginationProps } from "@/utils/importUsed"
// 表单实例
const ruleFormRef = ref()
export function useKxsCamp() {
  // 接口列表实例
  let UrlList = reactive(null)
  // 获取当前板块接口列表
  onMounted(async () => {
    UrlList = await getGroupUrl(["kxsSys"]);
    onSearch(ruleFormRef.value);
  
  });
  let form = reactive({
  createUserId:"", //发起人用户ID
  createUsername:"", //发起人姓名
  createCode:"", //发起人编码
  startTime:"", //开始时间
  endTime:"", //结束时间

  });
  const dataList = ref([]);
  const loading = ref(false);
  const dialogAddVisible = ref(false);
  const pagination = reactive<PaginationProps>({
    total: 0,
    pageSize: 10,
    currentPage: 1,
    background: true
  });
  const columns: TableColumnList = [
    {
      type: "selection",
      width: 55,
      align: "left",
      hide: ({ checkList }) => !checkList.includes("勾选列")
    },
    {
      label: "序号",
      type: "index",
      width: 70,
      hide: ({ checkList }) => !checkList.includes("序号列")
    },
        {
      label: "发起人用户ID",
      prop: "createUserId",
      minWidth: 200
    },
    {
      label: "发起人姓名",
      prop: "createUsername",
      minWidth: 200
    },
    {
      label: "发起人编码",
      prop: "createCode",
      minWidth: 200
    },
    {
      label: "开始时间",
      prop: "startTime",
      minWidth: 200
    },
    {
      label: "结束时间",
      prop: "endTime",
      minWidth: 200
    },

    {
      label: "操作",
      fixed: "right",
      width: 120,
      slot: "operation"
    }
  ];
  // 当前页数量切换
  function handleSizeChange(val: number) {
    if (typeof val === "number") {
      pagination.pageSize = val;
      onSearch(ruleFormRef.value);
    }
  }
  // 当前页码切换
  function handleCurrentChange(val: number) {
    console.log(`current page: ${val}`);
    if (typeof val === "number") {
      pagination.currentPage = val;
      onSearch(ruleFormRef.value);
    }
  }
  // 选择表格项
  function handleSelectionChange(val) {
    console.log(`SelectionChange: ${val}`);
    onSearch(ruleFormRef.value);
  }
  // 搜索列表
  async function onSearch(formEl) {
    // 表单校验拦截
    if (!formEl) return
    await formEl.validate(async (valid, fields) => {
      if (valid) {
        //表单校验成功回调
        console.log('submit!')
        // 状态调整为加载中
        loading.value = true;
        // 调用接口（需动态生成接口）
        const { status, msg, data }: any = await http.Request({
          method: UrlList.kxsSys.sysCamppage.method,
          url: UrlList.kxsSys.sysCamppage.url,
          params: {
            ...form,
            pageSize: pagination.pageSize,
            pageNum: pagination.currentPage
          }
        });
        dataList.value = data.records;
        pagination.total = data.total;
        setTimeout(() => {
          loading.value = false;
        }, 500);
      } else {
        //表单校验失败回调
        ElMessage({
          message: "请输入完整信息",
          type: "error"
        });
      }
    })
  }



    // 删除
  function handleDelete(row) {
    ElMessageBox.confirm(
      `是否删除该训练营? `,
      "提示",
      {
        confirmButtonText: "删除",
        cancelButtonText: "取消",
        type: "warning"
      }
    ).then(async () => {
      const { status, msg }: any = await http.Request({ method: UrlList.kxsSys.sysCampremoveById.method, url: UrlList.kxsSys.sysCampremoveById.url, params: String(row.id) });
      if (status === 1) {
        ElMessage({
          message: "删除成功",
          type: "success"
        });
        onSearch(ruleFormRef);
      } else {
        ElMessageBox.alert(msg, "提示", {
        confirmButtonText: "关闭",
        type: "warning"
      });
      };
    })
  }

    // 新增
  const addVisible = ref(false);
  function handleAdd() {
    addVisible.value = true;
  };

    // 训练营-开启/结束活动
  const editChangeStatusVisible = ref(false);
  const editChangeStatusFormData = ref({});
  function handleChangeStatus(row) {
    editChangeStatusVisible.value = true;
    // 表格数据赋值
    editChangeStatusFormData.value = row;
  };

  return {
    form,
    loading,
    columns,
    dataList,
    pagination,
    onSearch,
    handleSizeChange,
    handleCurrentChange,
    handleSelectionChange,
    ruleFormRef,

    handleAdd,
    addVisible,
    handleDelete,
    handleChangeStatus,
    editChangeStatusVisible,
    editChangeStatusFormData,

  };
}
